﻿using UnityEngine;
using System.Collections;

public class CharacterControl : MonoBehaviour {
	
	public float walkSpeed = 10.0f;
	public float crouchSpeed = 5.0f;
	public float runSpeed = 20.0f;
	
	private CharacterMotor chMotor;
	private CharacterController chCont;
	private Transform tr;
	private float height;
	
	// Use this for initialization
	void Start () {
		chMotor = GetComponent<CharacterMotor>();
		tr = transform;
		chCont = GetComponent<CharacterController>();
		height = chCont.height;
	}
	
	// Update is called once per frame
	void FixedUpdate () {
		float standardHeight = height;
		float speed = walkSpeed;
		float crouchHeight = 0.5f * standardHeight;
		float h = standardHeight;
		bool canStand = true;

		if(chCont.isGrounded && Input.GetKey(KeyCode.LeftShift)) {
			speed = runSpeed;
		}	

		Vector3 startPos = transform.position;
		float length =  (standardHeight - crouchHeight);

		if(Physics.Raycast( startPos , Vector3.up, length)) {
			canStand = false;
		} else {
			canStand = true;
		}

		if(Input.GetKey(KeyCode.LeftControl)) {
			h = crouchHeight;
			speed = crouchSpeed;
		}
		if(!canStand) {
			h = crouchHeight;
			speed = crouchSpeed;
		}
		
		chMotor.movement.maxForwardSpeed = speed;
		float lastHeight = chCont.height;
		chCont.height = Mathf.Lerp(chCont.height, h, 5 * Time.deltaTime);

		Vector3 tmpPosition = tr.position;
		tmpPosition.y += (chCont.height - lastHeight) / 2;
		tr.position = tmpPosition;
	}
}
